//ecrit pour l'arpschuino  www.arpschuino.fr
//un code pour 16 output en off/on (arpower ou relay ou flexinarp)
//pour que l'arpdress-board fonctionne, le port bas doit être débranché.


/*
Adressage avec l'Arpdress board

2 clignotements brefs = l'adresse est prise depuis l'EEPROM.
  Si l'arpdress board est branché cela peu vouloir dire que le port bas n'est pas débranché.
1 cligotement jaune (arpdress board) et 1 vert =  l'adresse est prise depuis l'arpdress board et écrite dans l'EEPROM.
1 cligotement jaune (arpdress board) et 10 vert =  l'adresse est non conforme, l'adresse par defaut est prise.

Puis la led verte vibrillonne dés qu'elle reçoit du DMX.
*/

#include <Wire.h>
#define ARPDRESS_BOARD 0x26

#include <EEPROM.h>
byte EEPROMaddr = 0;

#include <lib_dmx.h>

#define default_adress (1)//adresse par defaut
#define nbre_circuits (16)//

#define    DMX512     (0)  

int adress = default_adress;

byte led_temoin=4;
boolean var_led=LOW;

//////////////////////////PATCH////////////////////////////////////////////
byte output [16] = {3,5,6,13,12,9,10,11,2,8,14,15,16,17,18,19};

#define bascule 127  //la valeure ou passer de LOW à HIGH


void setup(){
 /////////////////////pin 2 à 19 en sorties////////////////////////////
  for(int i=2;i<18;i++)
    {
     pinMode(i, OUTPUT); 
    }

  digitalWrite(led_temoin, HIGH);
  
  arpdress_board();//prise en charge de l'arpdress board
///////////////////////////////////////////////////////////////////////

  
  ArduinoDmx0.attachRXInterrupt  (frame_received);
  ArduinoDmx0.set_control_pin(7);    // Arduino output pin for MAX485 input/output control (connect to MAX485 pins 2-3) 
  ArduinoDmx0.set_rx_address(adress);      // set rx0 dmx start address
  ArduinoDmx0.set_rx_channels(nbre_circuits);     // number of rx channels
  ArduinoDmx0.init_rx(DMX512);        // starts universe 0 as rx, NEW Parameter DMX mode
}



void loop()
{
  delay(500);//la led s'éteind apres 500ms sans reception DMX
  digitalWrite  (led_temoin,  HIGH);
} 

void frame_received(uint8_t universe) // Custom ISR: fired when all channels in one universe are received
{
  //led_temoin verte
  
    if (universe == 0) // USART0
  {
    if(var_led == 0)
    {
      digitalWrite  (led_temoin,  LOW); 
      var_led = 1;
    }
    else
    {
      digitalWrite  (led_temoin,  HIGH);
      var_led = 0;
    }
  }
  
  /////////////////
 for(int i=0;i<=nbre_circuits;i++)
   {
    if (ArduinoDmx0.RxBuffer[i]> bascule ){
      digitalWrite(output [i], HIGH);
    }
    else{
      digitalWrite(output [i], LOW);   
    }
   }


}

////////////////////////adressage avec l'arpdress board/////////////////////////////////////////////////////////////////

void arpdress_board(){
///////////////presence de l'arpdress-board ? /////////////////////////
  boolean arpdress = true;//variable pour indiquer la presence (ou non) de l'arpdress board 
  if ((digitalRead (18) == HIGH) && (digitalRead (19) == HIGH)){
 
    char arpdress_code[8] = {'a','r','p','d','r','e','s','s'};
    
  //  PORTC = PORTC | 00110000; //pullup sur sda et slc
    Wire.begin(); 
    Wire.beginTransmission(ARPDRESS_BOARD);      // declare l'adresse de l'esclave qui va recevoir le code
    Wire.write(0xB);                        // envoie la donnee
    Wire.endTransmission();                  // arrete la transmission
    
  //  digitalWrite(led_temoin,LOW);
    delay (500);
  //  digitalWrite(led_temoin,HIGH);
    
    Wire.requestFrom(ARPDRESS_BOARD, 8);     // request 8 bytes from slave
    
    if (Wire.available()) {
      char reponse[8] = {0};
      delay(200);
      for(int i=0; i<8; i++){
        reponse[i] = Wire.read();
      }
      delay(200);
      for(int i=0;i<8;i++) {
         if (arpdress_code[i]!=reponse[i]) arpdress = false;
      }
    } 
    
    else {
      arpdress = false;
    }
  } 
  else {
    arpdress = false;
  }
   /////////////////////////////////////////////////////////////////////////// 
    byte unite = 0;
    byte disaine = 0;
    byte centaine = 0;
    
    if (arpdress == true){//si l'arpdress-board est branche et le port bas debranche
  /////////////////////////I2C///////////////////////////////////////////
  //////envoie requete///////
      //Wire.begin(); 
      Wire.beginTransmission(ARPDRESS_BOARD);      // declare l'adresse de l'esclave qui va recevoir le code
      Wire.write(0xDE);                        // envoie la donnee
      Wire.endTransmission();                  // arrete la transmission
      delay(500);
      
      //////////on attend 3 byte//////////////////////////////////////////
  
      Wire.requestFrom(ARPDRESS_BOARD, 3);     // request 3 bytes from slave
       
      if (Wire.available()) {
    
         unite = Wire.read();
         disaine = Wire.read();
         centaine = Wire.read();
         
     //////////////////////////////EEPROM/////////////////////////////////
         EEPROM.write(EEPROMaddr, centaine);
         EEPROMaddr ++;
         EEPROM.write(EEPROMaddr, disaine);
         EEPROMaddr ++;
         EEPROM.write(EEPROMaddr, unite);
         bitWrite (PORTD,4,0);
         delay (500);
         bitWrite (PORTD,4,1);
      }
    }
    else{
       centaine = EEPROM.read(EEPROMaddr);
       EEPROMaddr ++;
       disaine = EEPROM.read(EEPROMaddr);
       EEPROMaddr ++;
       unite = EEPROM.read(EEPROMaddr);

       bitWrite (PORTD,4,0);     //  digitalWrite(led_temoin,LOW);
       delay (100);
       bitWrite (PORTD,4,1);
       delay (100);
       bitWrite (PORTD,4,0);
       delay (100);
       bitWrite (PORTD,4,1);
       
    }
    adress =(centaine*100)+(disaine*10)+(unite);
    if(adress<513 && adress>0){}
    else{
     adress=default_adress;
     for (int i=0;i<10;i++){
      bitWrite (PORTD,4,0);
      delay (500);
      bitWrite (PORTD,4,1);
      delay (500);
     }
   
    }
   
    delay(1000);
    
    TWBR=0;
    TWCR=0;//desactive l'I2C

    pinMode(18, OUTPUT);
    pinMode(19, OUTPUT);

}

